#include "wavelet.h"

class VagueDenoiser : public GenericVideoFilter {   
  float thresh;
  int wavetype;
  int method;
  int nsteps;
  bool chroma;
  Wavelet *wavelet;
  
  float* block;
  float* blockU;
  float* blockV;
  int width;
  int height;
  int widthU;
  int heightU;
  int size_Y;
  int size_UV;
  
 public:
  VagueDenoiser(PClip _child1, const float _threshold, const int _wavetype, const int _method, const int _nsteps, const bool _chroma, IScriptEnvironment* env);
  ~VagueDenoiser();
  PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
  void filter(float* block, int b);
  void DWTTransform(float* block, int b, int c, boolean d);
  unsigned char realToChar (float x);
  void filterBlockYV12(float* block,int height, int width, const BYTE* src, unsigned char* dst, int srcPitch, int dstPitch, int length);
  void filterBlockYUY2(float* block, float* blockU, float* blockV,int height, int width, const BYTE* src, unsigned char* dst, int srcPitch, int dstPitch, int length);
};
